import re
import numpy as np

patterns = []
patterns.append('checking (\d+)-th 2x2 Sudoku solution grid?')  # 0
patterns.append('found (\d+) 1x2 patterns')  # 1
patterns.append('found (\d+) 1x3 patterns')  # 2
patterns.append('found (\d+) 2x2 patterns')  # 3
patterns.append('found (\d+) 2x3 patterns')  # 4
patterns.append('found (\d+) 3x3 patterns')  # 5
patterns.append('there were (\d+) duplicates eliminated')  # 6
patterns.append('still (\d+) ua sets after duplicate detection')  # 7
patterns.append('memory just for higher degree sets: (\d+)')  # 8
patterns.append('current memory usage before backtracking: (\d+)')  # 9
patterns.append('starts now')  # 10
patterns.append('time for whole search: (\d+) ms')  # 11
patterns.append('time spend on checking candidates: (\d+)')  # 12
patterns.append('valid 3-clue Sudoku does exist: (\d+)')  # 13
patterns.append('searched through grid with index: (\d+)')  # 14
patterns.append('last layer and not hit all ua sets: (\d+)')  # 15
patterns.append('3-clue hitting sets enumerated: (\d+)')  # 16
patterns.append('peak memory usage: (\d+)')  # 17
patterns.append('smaller hitting-sets: (\d+)')  # 18
patterns.append('time to find ua sets: (\d+) ms')  # 19
patterns.append('found (\d+) ua sets of degree (\d+)')  # 20
patterns.append('count ignored (\d+) in layer: (\d+)')  # 21
patterns.append('count not ignored (\d+) in layer: (\d+)') # 22
patterns.append('count backtracked (\d+) for degree: (\d+)')  # 23
patterns.append('count not backtracked (\d+) for degree: (\d+)')  # 24

vars = [[]for i in range(len(patterns)-4)]

countHigher = [[] for i in range(6)]
ignored = [[] for i in range(3)]
notIgnored = [[] for i in range(3)]
backtracked = [[] for i in range(6)]
notBacktracked = [[] for i in range(6)]

for i in range(144):
    with open("out" + str(i) + ".txt") as f:
        content = f.readlines()
    content = [element.strip("\n") for element in content]

    for line in content:
        matchedPattern = False
        for index, pattern in enumerate(patterns):
            pat = re.compile(pattern)
            m = pat.match(line)
            if m:
                matchedPattern = True
                if index == 20:
                    countHigher[int(m.group(2))].append(int(m.group(1)))
                elif index == 21:
                    ignored[int(m.group(2))].append(int(m.group(1)))
                elif index == 22:
                    notIgnored[int(m.group(2))].append(int(m.group(1)))
                elif index == 23:
                    backtracked[int(m.group(2))].append(int(m.group(1)))
                elif index == 24:
                    notBacktracked[int(m.group(2))].append(int(m.group(1)))
                elif not index == 10:
                    vars[index].append(int(m.group(1)))
                break

        if not matchedPattern:
            print "couldn't match a pattern to a line, better check this line:"
            print line

for index, var in enumerate(vars):
    if index <= 19 and index != 10:
        print patterns[index] + " " + str(np.sum(var))

print "higherDegree"
for index, element in enumerate(countHigher):
    print str(index) + " " + str(element)
print "ignored"
for index, element in enumerate(ignored):
    print str(index) + " " + str(element)
print "not ignored"
for index, element in enumerate(notIgnored):
    print str(index) + " " + str(element)
print "backtracked"
for index, element in enumerate(backtracked):
    print str(index) + " " + str(element)
print "not backtracked"
for index, element in enumerate(notBacktracked):
    print str(index) + " " + str(element)