import re
import numpy as np
import sys

# http://stackoverflow.com/questions/736043/checking-if-a-string-can-be-converted-to-float-in-python
# accessed in August 2016
# thanks to Eric Leschinski for providing isfloat
def isfloat(value):
  try:
    float(value)
    return True
  except ValueError:
    return False

patterns = []
patterns.append('checking (\d+)-th 2x2 Sudoku solution grid?')  # 0
patterns.append('found (\d+) 1x2 patterns')  # 1
patterns.append('found (\d+) 1x3 patterns')  # 2
patterns.append('found (\d+) 2x2 patterns')  # 3
patterns.append('found (\d+) 2x3 patterns')  # 4
patterns.append('found (\d+) 3x3 patterns')  # 5
patterns.append('there were (\d+) duplicates eliminated')  # 6
patterns.append('still (\d+) ua sets after duplicate detection')  # 7
patterns.append('memory just for higher degree sets: (\d+)')  # 8
patterns.append('current memory usage before backtracking: (\d+)')  # 9
patterns.append('starts now')  # 10
patterns.append('time for whole search: (\d+) ms')  # 11
patterns.append('time spend on checking candidates: (\d+)')  # 12
patterns.append('valid 16-clue Sudoku does exist: (\d+)')  # 13
patterns.append('searched through grid with index: (\d+)')  # 14
patterns.append('last layer and not hit all ua sets: (\d+)')  # 15
patterns.append('16-clue hitting sets enumerated: (\d+)')  # 16
patterns.append('peak memory usage: (\d+)')  # 17
patterns.append('smaller hitting-sets: (\d+)')  # 18
patterns.append('time to find ua sets: (\d+) ms')  # 19
patterns.append('starts reading file, index is: (\d+)')  # 20
patterns.append('time to solve the (\d+)-th 17-clue Sudoku: (\d+) ms')  # 21
patterns.append('found (\d+) ua sets of degree (\d+)')  # 22
patterns.append('count ignored (\d+) in layer: (\d+)')  # 23
patterns.append('count not ignored (\d+) in layer: (\d+)')  # 24
patterns.append('count backtracked (\d+) for degree: (\d+)')  # 25
patterns.append('count not backtracked (\d+) for degree: (\d+)')  # 26

vars = [[]for i in range(21)]

timeSolved = [[] for i in range(100)]
countHigher = [[] for i in range(6)]
ignored = [[] for i in range(16)]
notIgnored = [[] for i in range(16)]
backtracked = [[] for i in range(6)]
notBacktracked = [[] for i in range(6)]

for i in range(100):
    with open("out" + str(i) + ".txt") as f:
        content = f.readlines()
    # get rid of scientific notation numbers
    content = [' '.join(map(lambda e : str(int(float(e))) if isfloat(e) else e, element.strip("\n").split(' '))) for element in content]

    for line in content:
        matchedPattern = False
        for index, pattern in enumerate(patterns):
            pat = re.compile(pattern)
            m = pat.match(line)
            # if index-th regular expression matches
            if m:
                matchedPattern = True
                if index == 21:
                    timeSolved[int(m.group(1))].append(int(m.group(2)))
                elif index == 22:
                    countHigher[int(m.group(2))].append(int(m.group(1)))
                elif index == 23:
                    ignored[int(m.group(2))].append(int(m.group(1)))
                elif index == 24:
                    notIgnored[int(m.group(2))].append(int(m.group(1)))
                elif index == 25:
                    backtracked[int(m.group(2))].append(int(m.group(1)))
                elif index == 26:
                    notBacktracked[int(m.group(2))].append(int(m.group(1)))
                elif not index == 10:
                    vars[index].append(int(m.group(1)))
                break

        if not matchedPattern:
            print "couldn't match a pattern to a line, better check this line:"
            print line

for index, var in enumerate(vars):
    if index <= 20 and index != 10:
        print patterns[index] + " " + str(np.mean(var)) if len(var) > 0 else str(var)

print "higherDegree"
for index, element in enumerate(countHigher):
    print str(index) + " " + str(element)
print "ignored"
for index, element in enumerate(ignored):
    print str(index) + " " + str(element)
print "not ignored"
for index, element in enumerate(notIgnored):
    print str(index) + " " + str(element)
print "backtracked"
for index, element in enumerate(backtracked):
    print str(index) + " " + str(element)
print "not backtracked"
for index, element in enumerate(notBacktracked):
    print str(index) + " " + str(element)

vars[8] = [float(e) for e in vars[8]]
print np.mean(np.divide(vars[8],vars[17]))